package jp.ogakisoft.quiz.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RadioButton;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.VerticalPanel;

public class QuizPanel extends AbstractPanel {
	private int page = 1;
	private QuizServiceAsync service = null;
	private String quizId;
	private String kind;
	private String answer;
	private RadioButton radio[];
	private CheckBox check[];
	private int score;
	private int count = 0;
	private int minPoint = 0;
	private int maxPoint = 0;
	private Button ansButton = null;
	private Button nextButton = null;
	private TextArea text = null;
	private Label textLabel = null;
	final Constant constant = (Constant) GWT.create(Constant.class);

	public QuizPanel(String quizId) {
		//System.out.println("QuizPanel: quizId="+quizId);
		this.quizId = quizId;
		clear();
	}

	public void show(final QuizServiceAsync service) {
		this.service = service;
		if (count == 0) {
			service.quizTitle(quizId, new CallbackHeader());
			RootPanel.get("centerTitle").add(new HTML(constant.CENTER_TITLE()));
			RootPanel.get("bottomTitle").add(new HTML(constant.BOTTOM_TITLE()));
			RootPanel.get("buttonTitle").add(new HTML(constant.BUTTON_TITLE()));
		}
		//if (page <= count) {
			service.quizCard(quizId, page, new CallbackBody());
		//}
	}

	private boolean answerCheck() {
		boolean ok = false;
		String checkOn = "";
		if (kind.equals("radio")) {
			for (int ix = 0; ix < radio.length; ix++) {
				// System.out.println(radio[ix]);
				if (radio[ix] != null && radio[ix].getValue() == true) {
					if (checkOn != "") {
						checkOn += ",";
					}
					checkOn += "" + (ix + 1);
				}
			}
			// System.out.println(checkOn);
			if (answer.equals(checkOn))
				ok = true;
		} else if (kind.equals("check")) {
			for (int ix = 0; ix < check.length; ix++) {
				if (check[ix] != null && check[ix].getValue() == true) {
					if (checkOn != "") {
						checkOn += ",";
					}
					checkOn += "" + (ix + 1);
				}
			}
			// System.out.println(checkOn);
			if (answer.equals(checkOn))
				ok = true;
		}
		return ok;
	}

	public void answer() {
		String text = "";
		if (answerCheck()){
			//text = constant.COLLECT();
			text = "<img src=\"maru.gif\">";
		}else{
			text = constant.WRONG();
			text = "<img src=\"batu.gif\">";
		}
		final DialogBox dialogBox = new DialogBox();
		Button closeButton = new Button(constant.CLOSE());
		//Label label = new Label(text);
		VerticalPanel dialogVPanel = new VerticalPanel();
		dialogVPanel.addStyleName("dialogVPanel");
		//dialogVPanel.add(label);
		dialogVPanel.add(new HTML(text));
		dialogVPanel.setHorizontalAlignment(VerticalPanel.ALIGN_RIGHT);
		dialogVPanel.add(closeButton);
		dialogBox.setAnimationEnabled(true);
		dialogBox.setWidget(dialogVPanel);
		dialogBox.setText(constant.ANSWER_CHECK());
		dialogBox.center();
		// dialogBox.setStyleName("answerDialog");
		closeButton.setFocus(true);
		closeButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				dialogBox.hide();
			}
		});
	}

	public void next() {
		if (answerCheck())
			score++;
		page++;
		show(service);
	}

	public class CallbackHeader extends AbstractPanel.Callback {
		@Override
		public void onSuccess(Object obj) {
			QuizIdPOJ title = (QuizIdPOJ)obj;
			//System.out.println("CallbackHeader: "+title.toString());
			try {
				count = Integer.parseInt(title.getCount());
				minPoint = Integer.parseInt(title.getMinPoint());
				maxPoint = Integer.parseInt(title.getMaxPoint());
			} catch (NumberFormatException e) {
				e.printStackTrace();
				System.out.println("QuizHeader {count, minPoint, maxPoint}={"
						+ title.getCount() + "," + title.getMinPoint() + ","
						+ title.getMaxPoint() + "}");
				onFailure(null);
			}
			Label label = new Label(title.getTitle());
			//VerticalPanel panel = new VerticalPanel();
			//panel.add(label);
			RootPanel.get("topContainer").add(label);
		}
	}

	public class CallbackBody extends AbstractPanel.Callback {
		private void showResult() {
			int point = (maxPoint / count) * score;
			String text = "";
			if (point >= minPoint){
				//text = constant.PASS();
				text = constant.PASS()+"<img src=\"pass.gif\">";
			} else {
				text = constant.FAIL()+"<img src=\"fail.gif\">";
			}
			RootPanel.get("centerTitle").clear();
			RootPanel.get("bottomTitle").clear();
			RootPanel.get("buttonTitle").clear();
			RootPanel.get("centerContainer").clear();
			RootPanel.get("bottomContainer").clear();
			RootPanel.get("buttonContainer").clear();
			RootPanel.get("centerContainer").add(
					new HTML(constant.RESULT_SCORE() + ":&nbsp;" + score
							+ ",&nbsp;" + constant.RESULT_POINT() + ":&nbsp;"
							+ point + "</br>"));
			RootPanel.get("centerContainer").add(new HTML(text));
			// if (nextButton == null) {
			nextButton = new Button(constant.NEXT());
			nextButton.addClickHandler(new ClickHandler() {
				public void onClick(ClickEvent event) {
					new StartPanel().show(service);
				}
			});
			RootPanel.get("buttonContainer").add(nextButton);
			// }
		}

		@Override
		public void onSuccess(Object obj) {
			QuizCardPOJ card = (QuizCardPOJ) obj;
			if (card == null) {
				showResult();
				return;
			}
			//System.out.println("CallbackBody: "+card.toString());
			kind = card.getKind();
			answer = card.getAnswer();

			if (textLabel == null) {
				textLabel = new Label();
			}
			if (text == null) {
				text = new TextArea();
				text.setReadOnly(true);
				text.setSize("450", "150");
				text.addStyleName("text");
			}
			textLabel.setText(constant.NO_X().replaceAll("x", ""+page));
			text.setText(card.getQuestion());
			RootPanel.get("centerContainer").add(textLabel);
			RootPanel.get("centerContainer").add(text);
			RootPanel.get("bottomContainer").clear();
			if (card.getKind().equals("radio")) {
				radio = new RadioButton[card.getChoose().length];
				for (int ix = 0; ix < card.getChoose().length; ix++) {
					if (card.getChoose()[ix] != null) {
						radio[ix] = new RadioButton("group");
						radio[ix].setText(card.getChoose()[ix]);
						// .setText("" + (ix + 1) + ":" + body.choose[ix]);
						RootPanel.get("bottomContainer").add(radio[ix]);
						RootPanel.get("bottomContainer").add(new HTML("</br>"));
					}
				}
			} else if (kind.equals("check")) {
				check = new CheckBox[card.getChoose().length];
				for (int ix = 0; ix < card.getChoose().length; ix++) {
					if (card.getChoose()[ix] != null) {
						check[ix] = new CheckBox();
						check[ix]
								.setText("" + (ix + 1) + ":" + card.getChoose()[ix]);
						RootPanel.get("bottomContainer").add(check[ix]);
						RootPanel.get("bottomContainer").add(new HTML("</br>"));
					}
				}
			}
			if (ansButton == null) {
				ansButton = new Button(constant.CHECK());
				ansButton.addClickHandler(new ClickHandler() {
					public void onClick(ClickEvent event) {
						answer();
					}
				});
				RootPanel.get("buttonContainer").add(ansButton);
			}
			if (nextButton == null) {
				nextButton = new Button(constant.NEXT());
				nextButton.addClickHandler(new ClickHandler() {
					public void onClick(ClickEvent event) {
						next();
					}
				});
				RootPanel.get("buttonContainer").add(nextButton);
			}
		}
	}
}
