package jp.ogakisoft.quiz.server;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class QuizJDO {
	@PrimaryKey
	@Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
	private Key id;
	@Persistent
	private String quizId;
	@Persistent
	private String seq;
	@Persistent
	private String kind;
	@Persistent
	private String point;
	@Persistent
	private String question;
	@Persistent
	private String answer;
	@Persistent
	private String[] choose;

	public Key getId() {
		return id;
	}

	public void setId(Key id) {
		this.id = id;
	}

	public String getQuizId() {
		return quizId;
	}

	public void setQuizId(String quizId) {
		this.quizId = quizId;
	}

	public String getSeq() {
		return seq;
	}

	public void setSeq(String seq) {
		this.seq = seq;
	}

	public String getKind() {
		return kind;
	}

	public void setKind(String kind) {
		this.kind = kind;
	}

	public String getPoint() {
		return point;
	}

	public void setPoint(String point) {
		this.point = point;
	}

	public String getQuestion() {
		return question;
	}

	public void setQuestion(String question) {
		this.question = question;
	}

	public String getAnswer() {
		return answer;
	}

	public void setAnswer(String answer) {
		this.answer = answer;
	}

	public String[] getChoose() {
		return choose;
	}

	public void setChoose(String[] choose) {
		this.choose = choose;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("QuizJDO {id=");
		builder.append(id);
		builder.append(",quizId=");
		builder.append(quizId);
		builder.append(",seq=");
		builder.append(seq);
		builder.append(",kind=");
		builder.append(kind);
		builder.append(", point=");
		builder.append(point);
		builder.append(", question=");
		builder.append(question);
		builder.append("answer=");
		builder.append(answer);
		builder.append(", choose=[");
		for (String s : choose) {
			builder.append(s + ",");
		}
		builder.append("]}");
		return builder.toString();
	}

}