package jp.ogakisoft.quiz.server;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.users.User;

@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class QuizUser {
	@PrimaryKey
	@Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
	private String userId;
	@Persistent
	private User user;
	@Persistent
	private Date startTime;
	@Persistent
	private String state;

	public QuizUser(String userId, User user, Date startTime) {
		setUserId(userId);
		setUser(user);
		setStartTime(startTime);
		setState("init");
	}

	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public Date getStartTime() {
		return startTime;
	}

	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("QuizUser{");
		builder.append("userId:").append(userId).append(",");
		builder.append("user:").append(user).append(",");
		builder.append("startTime:").append(startTime).append(",");
		builder.append("state:").append(state).append("}");
		return builder.toString();
	}
}
